# -*- coding: cp1250 -*-
# version 1.0, 8.1.2011
# programming Ctibor Plasek
# support : Ctibor.Plasek@Seznam.cz
# Pro pepnn mezi FullScreen a Window stisknte "f".

import os, pygame, datetime, time
from pygame.locals import *
from sys import exit

#Nastaven souadnic, kam se m zobrazit okno pygame
x = 50 
y = 50
os.environ['SDL_VIDEO_WINDOW_POS'] = "%d,%d" % (x,y)

pygame.init()
screen = pygame.display.set_mode((800, 600), 1, 32)
pygame.display.set_caption("Kiovatka")

clock = pygame.time.Clock()


clock_tick = 30 # Nastaven obnovovac frekvence

barva = ['cervena.png','cervenazluta.png','zelena.png','zluta.png','chodcicervena.png','chodcizelena.png','tlacitkotma.png','tlacitkosviti.png']

background_image_filename = 'podklad.png'
background = pygame.image.load(background_image_filename).convert()
# Naten jednotlivch obrzk
cervena = pygame.image.load(barva[0]).convert()
cervenazluta = pygame.image.load(barva[1]).convert()
zelena = pygame.image.load(barva[2]).convert()
zluta = pygame.image.load(barva[3]).convert()
chodcicervena = pygame.image.load(barva[4]).convert()
chodcizelena = pygame.image.load(barva[5]).convert()
tlacitkotma = pygame.image.load(barva[6]).convert()
tlacitkosviti = pygame.image.load(barva[7]).convert()

# Souadnice semafor a tlatek
semafory = [265,48,180],[593,166,90],[507,488,0],[148,408,270]
chodci = [220,160,0],[220,405,180],[260,120,90],[505,120,270],[562,160,0],[562,405,180],[260,460,90],[505,460,270]
tlac = [240,184,180],[240,405,0],[284,140,270],[505,140,90],[534,184,180],[534,405,0],[284,432,270],[505,432,90]

# Nastaven potench hodnot
casStart = time.time()
casBlik = 0
blikej = 0
tlstisk = 0
fullscreen = 0


def Semafor(barv,t):# Rozmstn semafor
    global tl
    tl=t
    semafor = [1,2,3,4]
    chsemafor = [1,2,3,4,5,6,7,8]
    
    if barv == 0:
        for i in range(0,4,2):
            semafor[i] = pygame.transform.rotate(cervena, semafory[i][2])
            semafor[i+1] = pygame.transform.rotate(zelena, semafory[i+1][2])
        if tl == 2:# Pokud blikaj tlatka, tak se vypnou
            tl = 0
    if barv == 1:
        for i in range(0,4,2):
            semafor[i] = pygame.transform.rotate(cervenazluta, semafory[i][2])
            semafor[i+1] = pygame.transform.rotate(zluta, semafory[i+1][2])
        tl = 0 # Aby nelo zapnout tlatka ve smru, kde svt zelen
    if barv == 2:
        for i in range(0,4,2):
            semafor[i] = pygame.transform.rotate(zelena, semafory[i][2])
            semafor[i+1] = pygame.transform.rotate(cervena, semafory[i+1][2])
        if tl == 1:# Pokud blikaj tlatka, tak se vypnou
            tl = 0
    if barv == 3:
         for i in range(0,4,2):
            semafor[i] = pygame.transform.rotate(zluta, semafory[i][2])
            semafor[i+1] = pygame.transform.rotate(cervenazluta, semafory[i+1][2])
         tl = 0 # Aby nelo zapnout tlatka ve smru, kde svt zelen

    for i in range(0,8): # Vechny semafory chodc maj automaticky ervenou
        chsemafor[i] = pygame.transform.rotate(chodcicervena, chodci[i][2])
    
    if barv == 0: # Pouze ve sprvnm smru se pebarv na zelenou
        chsemafor[2] = pygame.transform.rotate(chodcizelena, chodci[2][2])
        chsemafor[3] = pygame.transform.rotate(chodcizelena, chodci[3][2])
        chsemafor[6] = pygame.transform.rotate(chodcizelena, chodci[6][2])
        chsemafor[7] = pygame.transform.rotate(chodcizelena, chodci[7][2])
    if barv == 2:
        chsemafor[0] = pygame.transform.rotate(chodcizelena, chodci[0][2])
        chsemafor[1] = pygame.transform.rotate(chodcizelena, chodci[1][2])
        chsemafor[4] = pygame.transform.rotate(chodcizelena, chodci[4][2])
        chsemafor[5] = pygame.transform.rotate(chodcizelena, chodci[5][2])
    
    for i in range(0,4): # Pekreslen obrzk
        screen.blit(semafor[i],(semafory[i][0],semafory[i][1]))

    for i in range(0,8):
        screen.blit(chsemafor[i],(chodci[i][0],chodci[i][1]))


def Tlacitka(tlstisk, blik):
    if blik < 5: blikej = 0 # Nastaven blikn kadch 0.5s
    if blik >= 5: blikej = 1
    tlacitko = [1,2,3,4,5,6,7,8]

# Rozmstn tlatek nerozsvcench a rozsvcench
    for i in range(0,8): 
        tlacitko[i] = pygame.transform.rotate(tlacitkotma, tlac[i][2])

    if (tlstisk == 1 and blikej == 1):
        tlacitko[0] = pygame.transform.rotate(tlacitkosviti, tlac[0][2])
        tlacitko[1] = pygame.transform.rotate(tlacitkosviti, tlac[1][2])
        tlacitko[4] = pygame.transform.rotate(tlacitkosviti, tlac[4][2])
        tlacitko[5] = pygame.transform.rotate(tlacitkosviti, tlac[5][2])

    if (tlstisk == 2 and blikej == 1):
        tlacitko[2] = pygame.transform.rotate(tlacitkosviti, tlac[2][2])
        tlacitko[3] = pygame.transform.rotate(tlacitkosviti, tlac[3][2])
        tlacitko[6] = pygame.transform.rotate(tlacitkosviti, tlac[6][2])
        tlacitko[7] = pygame.transform.rotate(tlacitkosviti, tlac[7][2])
    
    for i in range(0,8): # Pekreslen obrzk tlatek
        screen.blit(tlacitko[i], (tlac[i][0],tlac[i][1]))

while True:
    clock.tick(clock_tick) # Nastaven obnovovac frekvece
    screen.blit(background, (0,0)) # Vykreslen pozad

    for event in pygame.event.get(): # Kontrola udlost - Esc=Quit, F = pepn mezi fullscreen a okno
        if event.type == QUIT:
            pygame.quit()
        if event.type == KEYDOWN:
            if event.key == K_ESCAPE:
                pygame.quit()
            if event.key == K_f:
                if fullscreen == 0:
                    fullscreen = 1
                    print fullscreen
                    screen = pygame.display.toggle_fullscreen()
                    screen = pygame.display.set_mode((800, 600), FULLSCREEN, 32)
                elif fullscreen == 1:
                    fullscreen = 0
                    print fullscreen
                    screen = pygame.display.set_mode((800, 600), 1, 32)    
    
        # x,y - pozice myi a nsledn kontrola
        x, y = pygame.mouse.get_pos()

        if event.type == MOUSEBUTTONDOWN and (((x>240 and x<270) and ((y>184 and y<200)or(y>405 and y<421)))or
                                              ((x>534 and x<564) and ((y>184 and y<200)or(y>405 and y<421)))):
            if tlstisk != 2:# Pokud nebyl stisknut druh smr
                tlstisk = 1 # tak zapni
        
        if event.type == MOUSEBUTTONDOWN and (((x>284 and x<296) and ((y>140 and y<170)or(y>432 and y<462)))or
                                              ((x>505 and x<523) and ((y>140 and y<170)or(y>432 and y<462)))):
            if tlstisk != 1:# Pokud nebyl stisknut druh smr
                tlstisk = 2 # tak zapni


# Nastavovn a vpoet asu, kter je v desetinch sec. kvli blikn
    casEnd = time.time()
    cas = (casEnd - casStart)*10
    cas = int(cas)
    if cas == 480:
        casStart = time.time()
    if cas == 0:barv=0
    if cas == 200:barv=1
    if cas == 240:barv=2
    if cas == 440:barv=3

    Semafor(barv,tlstisk)
    tlstisk = tl
    Tlacitka(tlstisk, casBlik)
    pismo = pygame.font.Font("arial.ttf", 36)
    if cas < 10:
        cas1 = "00" + str(cas)
    elif cas < 100:
        cas1 = "0" + str(cas)
    else:
        cas1 = str(cas)
    if cas==0:cas1='000'

    casBlik = int(cas1[2]) # Oezn pouze desetin sec.

    #cas1 = cas1[0:2]+ "." + cas1[2]
    #text = pismo.render(cas1, 1, (255, 255, 0))
    #screen.blit(text, (690,20)) # Vykreslen asu na obrazovku

    
    pygame.display.update() # Update cel obrazovky (resp.okna)
